// CCCDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CCCDemo.h"
#include "CCCDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

typedef  int (CALLBACK *SYNCHRO_WRITE)(DWORD, DWORD, float);
typedef  int (CALLBACK *SYNCHRO_READ)(DWORD, DWORD, float *);
typedef  int (CALLBACK *SYNCHRO_RESOLUTION)(DWORD, DWORD, DWORD);
typedef  int (CALLBACK *SYNCHRO_TEST)(DWORD, DWORD, DWORD);

HINSTANCE dllHandle = NULL;
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCCCDemoDlg dialog

CCCCDemoDlg::CCCCDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCCCDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCCCDemoDlg)
	m_Angle = _T("");
	m_Card = _T("");
	m_Channel = _T("");
	m_CH0 = _T("");
	m_CH1 = _T("");
	m_CH2 = _T("");
	m_CH3 = _T("");
	m_CH4 = _T("");
	m_CH5 = _T("");
	m_CH6 = _T("");
	m_CH7 = _T("");
	m_error = _T("");
	m_resolution = _T("");
	m_test = _T("");
	m_error0 = _T("");
	m_error1 = _T("");
	m_error2 = _T("");
	m_error3 = _T("");
	m_error4 = _T("");
	m_error5 = _T("");
	m_error6 = _T("");
	m_error7 = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCCCDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCCCDemoDlg)
	DDX_Text(pDX, IDC_ANGLE, m_Angle);
	DDX_Text(pDX, IDC_CARD, m_Card);
	DDX_Text(pDX, IDC_CHANNEL, m_Channel);
	DDX_Text(pDX, IDC_CH0, m_CH0);
	DDX_Text(pDX, IDC_CH1, m_CH1);
	DDX_Text(pDX, IDC_CH2, m_CH2);
	DDX_Text(pDX, IDC_CH3, m_CH3);
	DDX_Text(pDX, IDC_CH4, m_CH4);
	DDX_Text(pDX, IDC_CH5, m_CH5);
	DDX_Text(pDX, IDC_CH6, m_CH6);
	DDX_Text(pDX, IDC_CH7, m_CH7);
	DDX_Text(pDX, IDC_ERROR, m_error);
	DDX_Text(pDX, IDC_RESOLUTION, m_resolution);
	DDX_Text(pDX, IDC_TEST, m_test);
	DDX_Text(pDX, IDC_ERROR0, m_error0);
	DDX_Text(pDX, IDC_ERROR1, m_error1);
	DDX_Text(pDX, IDC_ERROR2, m_error2);
	DDX_Text(pDX, IDC_ERROR3, m_error3);
	DDX_Text(pDX, IDC_ERROR4, m_error4);
	DDX_Text(pDX, IDC_ERROR5, m_error5);
	DDX_Text(pDX, IDC_ERROR6, m_error6);
	DDX_Text(pDX, IDC_ERROR7, m_error7);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCCCDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CCCCDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_EN_CHANGE(IDC_ANGLE, OnChangeAngle)
	ON_EN_CHANGE(IDC_RESOLUTION, OnChangeResolution)
	ON_EN_CHANGE(IDC_TEST, OnChangeTest)
	ON_BN_CLICKED(IDREAD, OnRead)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCCCDemoDlg message handlers

BOOL CCCCDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_Card.Format("%.0f", 0);
	m_Channel.Format("%.0f", 0);
	m_Angle.Format("%.1f", 1);
	m_test.Format("%.0f", 0);
	m_resolution.Format("%.0f", 0);
	UpdateData(FALSE);
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCCCDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCCCDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCCCDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}



void CCCCDemoDlg::OnChangeAngle() 
{
	SYNCHRO_WRITE  synchro_write;
	DWORD cc_card;
	DWORD cc_channel;
    float cc_angle;
	int error;

	if (dllHandle == NULL)
		dllHandle=LoadLibrary("cccsync.dll");

	synchro_write = (SYNCHRO_WRITE)GetProcAddress(dllHandle,"synchro_write");

	UpdateData(TRUE);
	cc_card = atoi(m_Card);
	cc_channel = atoi(m_Channel);
	cc_angle = (float) atof(m_Angle);
	error = synchro_write(cc_card, cc_channel, cc_angle);
	m_error.Format("%d", error);
	
	UpdateData(FALSE);

	FreeLibrary(dllHandle);
	dllHandle = NULL;	
}


void CCCCDemoDlg::OnChangeResolution() 
{
	SYNCHRO_RESOLUTION  synchro_resolution;
	DWORD cc_card;
	DWORD cc_channel;
    DWORD cc_resolution;
	int error;

	if (dllHandle == NULL)
		dllHandle=LoadLibrary("cccsync.dll");
	synchro_resolution = (SYNCHRO_RESOLUTION)GetProcAddress(dllHandle,"synchro_resolution");

	UpdateData(TRUE);
	cc_card = atoi(m_Card);
	cc_channel = atoi(m_Channel);
	cc_resolution = atoi(m_resolution);
	error = synchro_resolution(cc_card, cc_channel, cc_resolution);
	m_error.Format("%d", error);
	
	UpdateData(FALSE);

	FreeLibrary(dllHandle);
	dllHandle = NULL;	
}

void CCCCDemoDlg::OnChangeTest() 
{
	SYNCHRO_TEST  synchro_test;
	DWORD cc_card;
	DWORD cc_channel;
	DWORD cc_test;
	int error;

	if (dllHandle == NULL)
		dllHandle=LoadLibrary("cccsync.dll");
	synchro_test = (SYNCHRO_TEST)GetProcAddress(dllHandle,"synchro_test");

	UpdateData(TRUE);
	cc_card = atoi(m_Card);
	cc_channel = atoi(m_Channel);
	cc_test = atoi(m_test);
	error = synchro_test(cc_card, cc_channel, cc_test);
	m_error.Format("%d", error);
	
	UpdateData(FALSE);

	FreeLibrary(dllHandle);
	dllHandle = NULL;	
}


void CCCCDemoDlg::OnOK() 
{
	CDialog::OnOK();
}

void CCCCDemoDlg::OnRead() 
{
	SYNCHRO_READ  synchro_read = NULL;
	DWORD cc_card;
	DWORD cc_channel;
    float cc_angle;
	int error;


	if (dllHandle == NULL)
		dllHandle=LoadLibrary("cccsync.dll");

	synchro_read = (SYNCHRO_READ)GetProcAddress(dllHandle,"synchro_read");

	UpdateData(TRUE);
	cc_card = atoi(m_Card);
	cc_channel = atoi(m_Channel);
	cc_angle = (float) atof(m_Angle);

	error = synchro_read(cc_card, 0,  &cc_angle);
	m_CH0.Format("%.4f", cc_angle);
	m_error0.Format("%d", error);
	error = synchro_read(cc_card, 1,  &cc_angle);
	m_CH1.Format("%.4f", cc_angle);
	m_error1.Format("%d", error);
	error = synchro_read(cc_card, 2,  &cc_angle);
	m_CH2.Format("%.4f", cc_angle);
	m_error2.Format("%d", error);
	error = synchro_read(cc_card, 3,  &cc_angle);
	m_CH3.Format("%.4f", cc_angle);
	m_error3.Format("%d", error);
	error = synchro_read(cc_card, 4,  &cc_angle);
	m_CH4.Format("%.4f", cc_angle);
	m_error4.Format("%d", error);
	error = synchro_read(cc_card, 5,  &cc_angle);
	m_CH5.Format("%.4f", cc_angle);
	m_error5.Format("%d", error);
	error = synchro_read(cc_card, 6,  &cc_angle);
	m_CH6.Format("%.4f", cc_angle);
	m_error6.Format("%d", error);
	error = synchro_read(cc_card, 7,  &cc_angle);
	m_CH7.Format("%.4f", cc_angle);
	m_error7.Format("%d", error);	

	UpdateData(FALSE);
	
	FreeLibrary(dllHandle);
	dllHandle = NULL;		
}
